﻿<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.inscription.name`)" />
        <BackLinkTitle :title="t(`routes.inscription.name`)" />
        <Card>
            <WaitingMemberForm @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>



<script lang="ts" setup>
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
import Card from "@/components/layout/Card.vue";
import { useI18n } from "vue3-i18n";
import { WaitingMember } from "@/types/entities/waitingMember";
import WaitingMemberForm from "@/components/waitingMembers/WaitingMemberForm.vue"
import {notifyError, notifySuccess} from "@/notify";
import {useWaitingMemberService} from "@/inversify.config"
import { ICreateWaitingMemberRequest } from "@/types/requests/createWaitingMemberRequest"
import {ICreateBookRequest} from "@/types/requests/createBookRequest";
import {useRouter} from "vue-router";
const {t} = useI18n()
const router = useRouter();
const waitingMemberService = useWaitingMemberService();

async function handleSubmit(waitingMember : WaitingMember) {
    let succeededOrNotResponse = await waitingMemberService.createWaitingMember(waitingMember as ICreateWaitingMemberRequest)
    if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
        notifySuccess(t('validation.waitingMember.add.success'))
        setTimeout(() => {
            router.back();
        }, 1500);
    } else {
        let errorMessages = succeededOrNotResponse.getErrorMessages('validation.waitingMember.add');
        if (errorMessages.length == 0)
            notifyError(t('validation.waitingMember.add.errorOccured'))
        else
            notifyError(errorMessages[0])
    }
}
</script>
